﻿import mx.events.EventDispatcher;
import utils.*;

class Tetris.Level extends MovieClip{
	public var dispatchEvent:Function;
	public var addEventListener:Function;
	public var removeEventListener:Function;
	
	/*stati: 0 crea i blocchi, li fa scorrere e li posa
	         1 inizio transizione riga completata
			 2 tetris in pausa
			 3 game over*/
	private var KUp:Number=Key.UP;
	private var KDown:Number=Key.DOWN;
	private var KLeft:Number=Key.LEFT;
	private var KRight:Number=Key.RIGHT;
	private var KDrop:Number=Key.SPACE;
	private var KeyPause:String="P";
	var ToPause:Boolean=false;
	var ToStop:Boolean=false;
	private var nLevel:Number;

	private var lScore:Number;
	private var vLines:Number;
	private var Matrix= new Array(22);
	private var TState:Number;
	private var pmode:String="anyKey"
	private var pflag:Boolean=false;
	
	private var Levels:Tetris.LevelType;
	var accelerate:Boolean=false;
	private var nBlock:Number;
	private var cBlock:Boolean=false;	
	private var Blocks:Tetris.BlockType;
	private var NextBlock:Number;
	private var offL:Array;
	private var offC:Array;
	private var color:String;
	private var cLine:Number;
	private var cCol:Number;
	private var bState:Number;//see details in Tetris.BlockType
	private var LinesToDel:Array;
	private var transictionEnd:Boolean;
	private var TimerDown:Timer;
	private var TimerAlpha:Timer;
	private var LinesToGo:Number=2;
	var dBrick:Number=15;
	
	function Level(){
		EventDispatcher.initialize(this);
	}
	
	function initApp(initobj:Object){
			Blocks=new Tetris.BlockType();
			Levels=new Tetris.LevelType();
			LinesToDel=new Array();
			TimerDown=new Timer();
			TimerAlpha=new Timer(initobj._delayAlpha);
			KeyTime.setKT(initobj);
			lScore=0;
	}
	
	function initLevel(_nLevel:Number):Boolean{
		var i,j:Number;
		var Name:String;
		if(_nLevel<=Levels.getTotLevels()){
			ToStop=ToPause=pflag=false;
			TState=0;
			vLines=0;
			nLevel=_nLevel;
			if(Blocks!=undefined)
				for(i=0;i<Blocks.iMatrix[0];i++)
					for(j=0;j<Blocks.iMatrix[1];j++)
						if(Blocks.bMatrix[i][j])
							eval("this.brick"+Blocks.bMatrix[i][j]).removeMovieClip();
			bState=0;
			nBlock=1;
			cBlock=false;
			NextBlock=GetRandomBlock();
			for(i=0;i<22;i++){
				if(Matrix[i]==undefined)Matrix[i]=(new Array(10));
				for(j=0;j<10;j++){
					if(Matrix[i][j]>0) eval("this.brick"+Matrix[i][j]).removeMovieClip();
					Matrix[i][j]=0;
				}
			}
			Levels.GetLevel(nLevel, accelerate);
			TimerDown.setDelay(Levels._Delay);
			for(Name in Levels.Lv)
				for(i=0;i<Levels.Lv[Name].length;i++){
					if(Matrix[Levels.Lv[Name][i][0]][Levels.Lv[Name][i][1]]!=0){
						trace("Level "+nLevel);
						trace("Error in Lv."+Name+"["+i+"]");
						return(false);
					}
					else{
						Matrix[Levels.Lv[Name][i][0]][Levels.Lv[Name][i][1]]=nBlock;
						attachMovie("asBrick","brick"+nBlock,nBlock);
						eval("this.brick"+nBlock)._x=dBrick*(Levels.Lv[Name][i][1]);
						eval("this.brick"+nBlock)._y=dBrick*(21-Levels.Lv[Name][i][0]);
						eval("this.brick"+nBlock).gotoAndStop(Name);
						(nBlock>3000)?nBlock=1:nBlock++;
					}
				}
			this.dispatchEvent({type:"onInitLevel", target:_parent, level:nLevel});
			return(true);
		}else return(false);
	}
			
	private function runBlocks(){	
		var i:Number;
		updateAfterEvent();
		switch(TState){
			case 0:// crea i blocchi, li fa scorrere e li posa
				if(!cBlock){ 
					if(initBlock())
						TimerDown.TReset();
					else {
						TState=3;
						break;
					}
				}
				i=getKey();
				if(KeyTime.Check(i)) evalKey(i);
				if(i!=2){
					if(TimerDown.cTime()){
						ShiftDown();
					}
				}
				break;
			case 1:// Transizione righe
				doTransition();
				break;
			case 2://pause
				if(pmode=="anyKey"){
					i=getKey();
					if(KeyTime.Check(i)){
						TState=0;
						pflag=false;
						this.dispatchEvent({type:"onEndPause", target:_parent});
					}
				}else if (getKey()==9){
						TState=0;
						pflag=false;
						this.dispatchEvent({type:"onEndPause", target:_parent});
				}
				break;
			case 3:// Game over
				this.dispatchEvent({type:"onGameOver", target:_parent});
				this.onEnterFrame=undefined;
				break;
			case 4:// Game win
				this.dispatchEvent({type:"onWin", target:_parent});
				this.onEnterFrame=undefined;
				break;				
			case 5://Init new Level
				if(!initLevel(nLevel+1)) TState=4;
				else{
					eval(_target+".sNextBlock").gotoAndStop(NextBlock+1);
					TState=2;
					pflag=true;
				}
				break;
		}
	}
		
	private function evalKey(i:Number){
		switch(i){
			case 1:
				Rotate();
				break;
			case 2:
				ShiftDown();
				break;
			case 3:
				ShiftLR("left");
				break;
			case 4:
				ShiftLR("right");
				break;
			case 5:
				this.dispatchEvent({type:"onPause", target:_parent});
				TState=2;
				pflag=true;
				break;
			case 7://drop key
				TimerDown.setDelay(25);
				break;
		}
	}
	
	private function doTransition(){
		var i,j,k,bAlpha:Number;
		if(transictionEnd==false){
			bAlpha=eval("this.brick"+Matrix[LinesToDel[0]][0])._alpha;
			if(bAlpha>10){
				if(TimerAlpha.cTime())
					for(i=0;i<LinesToDel.length;i++)
						for(j=0;j<10;j++)
							eval("this.brick"+Matrix[LinesToDel[i]][j])._alpha-=10;
			}else{
				k=0;
				for(i=LinesToDel[0];i<22;i++){
					if((i==LinesToDel[k])&&(k<LinesToDel.length)){
						for(j=0;j<10;j++) 
							eval("this.brick"+Matrix[i][j]).removeMovieClip();								
						k++;
					}else{
						if(i==21){
							for(j=0;j<10;j++) Matrix[i-k][j]=0;
						}else{
							for(j=0;j<10;j++) 
								Matrix[i-k][j]=Matrix[i][j];
						}
						for(j=0;j<10;j++){
							eval("this.brick"+Matrix[i-k][j])._y+=dBrick*k;
						}
					}
				}
				transictionEnd=true;
				this.dispatchEvent({type:"onLinesDeleted", target:_parent, lines:LinesToDel.length});
			}
		}else{
			if(vLines<LinesToGo) TState=0;
			else TState=5;
		}
	}
	
	private function Rotate(){
		var i,j,k,dist:Number;
		var canRotate:Boolean=true;
		var lbMatrix,liMatrix:Array;
		lbMatrix=new Array(Blocks.iMatrix[1]);
		liMatrix=new Array(3);
		for(i=Blocks.iMatrix[1]-1;i>=0;i--){
			lbMatrix[Blocks.iMatrix[1]-1-i]=new Array(Blocks.iMatrix[0]);
			for(j=0;j<Blocks.iMatrix[0];j++)
				lbMatrix[Blocks.iMatrix[1]-1-i][j]=Blocks.bMatrix[j][i];
		}
		liMatrix[0]=Blocks.iMatrix[1];
		liMatrix[1]=Blocks.iMatrix[0];
		canRotate=checkBlock(cLine+offL[bState],cCol+offC[bState],lbMatrix,liMatrix);
		if(canRotate){
			cLine+=offL[bState];
			cCol+=offC[bState];
		}else{
			dist=10;
			j=k=cCol;
			for(i=cCol;i>=0;i--)
				if(Matrix[cLine+offL[bState]][i]==0) k=i;
				else i=-1;
			for(i=cCol;i<10;i++)
				if(Matrix[cLine+offL[bState]][i]==0) j=i;
				else i=10;
			for(i=k;i<j;i++)
				if(checkBlock(cLine+offL[bState],i,lbMatrix,liMatrix))
					if(Math.abs(cCol+offC[bState]-i)<Math.abs(dist)){
						dist=cCol+offC[bState]-i;
						canRotate=true;
					}
			if(canRotate){
				cLine+=offL[bState];
				cCol=cCol+offC[bState]-dist;
			}
		}
		if(canRotate){
			(bState==3)?bState=0:bState++;
			for(i=0;i<liMatrix[0];i++)
				for(j=0;j<liMatrix[1];j++)
					if (lbMatrix[i][j]){
						eval("this.brick"+lbMatrix[i][j])._x=dBrick*(cCol+j);
						eval("this.brick"+lbMatrix[i][j])._y=dBrick*(21-(cLine+i));
					}
			Blocks.bMatrix=lbMatrix;
			Blocks.iMatrix=liMatrix;
		}
	}
	
	private function ShiftLR(BDirection:String){
		var i,j,dir:Number;
		var NextFree:Boolean=true;
		(BDirection=="left")?dir=-1:dir=1;
		if(BDirection=="left"){
			if (cCol==0) NextFree=false;
		}else if (cCol==10) NextFree=false;
		if(NextFree==true)
			NextFree=checkBlock(cLine,cCol+dir,Blocks.bMatrix,Blocks.iMatrix);
		if(NextFree==true){
			for(i=0;i<Blocks.iMatrix[0];i++)
				for(j=0;j<Blocks.iMatrix[1];j++)
					if(Blocks.bMatrix[i][j])
						eval("this.brick"+Blocks.bMatrix[i][j])._x+=dBrick*dir;
			cCol+=dir;
		}
	}
		
	private function ShiftDown(){
		var i,j:Number;
		var NextFree:Boolean=true;
		if(cLine!=0) NextFree=checkBlock(cLine-1,cCol,Blocks.bMatrix,Blocks.iMatrix);
		if((cLine==0)||(NextFree==false)){
			for(i=0;i<Blocks.iMatrix[0];i++)
				for(j=0;j<Blocks.iMatrix[1];j++)
					if(Blocks.bMatrix[i][j])
						Matrix[cLine+i][cCol+j]=Blocks.bMatrix[i][j];
			cBlock=false;
			checkLines(cLine,cLine+Blocks.iMatrix[0]-1);
			KeyTime.Reset();
			TimerDown.setDelay(Levels._Delay);
		}
		else if(NextFree==true){
				for(i=0;i<Blocks.iMatrix[0];i++)
					for(j=0;j<Blocks.iMatrix[1];j++)
						if(Blocks.bMatrix[i][j])
							eval("this.brick"+Blocks.bMatrix[i][j])._y+=dBrick;
			 	cLine--;
			 }
	}
		
	private function checkLines(L1:Number,L2:Number){
		var i,j:Number;
		var insLine:Boolean;
		LinesToDel.length=0;
		for(i=L1;i<=L2;i++){
			insLine=true;
			for(j=0;j<10;j++)
				if(Matrix[i][j]==0) insLine=false;
			if(insLine) LinesToDel.push(i);
		}
		if(LinesToDel.length>0){
			vLines+=LinesToDel.length;
			lScore+=LinesToDel.length;
			TimerAlpha.TReset();
			transictionEnd=false;
			TState=1;
		}
	}
	
	private function initBlock():Boolean{
		var i,j:Number;
		Blocks.GetBlock(NextBlock);
		NextBlock=GetRandomBlock();
		eval(_target+".sNextBlock").gotoAndStop(NextBlock+1);
		color=Blocks.bColor;
		offL=Blocks.bOffL;
		offC=Blocks.bOffC;
		if(!checkBlock(22-Blocks.iMatrix[0],3,Blocks.bMatrix,Blocks.iMatrix))
			return (false);
		for(i=0;i<Blocks.iMatrix[0];i++)
			for(j=0;j<Blocks.iMatrix[1];j++)
				if(Blocks.bMatrix[i][j]){
					Blocks.bMatrix[i][j]=nBlock;
					attachMovie("asBrick","brick"+nBlock,nBlock);
					eval("this.brick"+nBlock)._x=dBrick*(j+3);
					eval("this.brick"+nBlock)._y=dBrick*(Blocks.iMatrix[0]-1-i);
					eval("this.brick"+nBlock).gotoAndStop(color);
					(nBlock>3000)?nBlock=1:nBlock++;
				}
		cBlock=true;
		cLine=22-Blocks.iMatrix[0];
		cCol=3;
		bState=0;
		return(true);
	}
		
	private function checkBlock(Line:Number, Col:Number, bMatrix:Array, iMatrix:Array):Boolean{
		var i,j:Number;
		for(i=0;i<iMatrix[0];i++)
			for(j=0;j<iMatrix[1];j++)
				if(bMatrix[i][j])
					if(Matrix[Line+i][Col+j]!=0) return(false);
		return(true);
	}
	
	private function GetRandomBlock():Number{
		var i:Number;
		i=Math.floor(Math.random()*7)+1;
		return(i);
	}
					
	private function getKey():Number{
		if(ToPause==true){
			ToPause=false;
			if(pflag==false) return(5);
			else return(9);
		}else if(ToStop==true){
				TState=3;//Game over
				return(0);
			}
		if(Key.isDown(KUp)) return(1);
		else if(Key.isDown(KDown)) return(2);
		 	 else if(Key.isDown(KLeft)) return(3);
				  else if(Key.isDown(KRight)) return(4);
					   else if(Key.isDown(KeyPause.charCodeAt(0)))return(5);
					   		else if(Key.isDown(Key.ENTER))return(6);
					  			else if(Key.isDown(KDrop)) return(7);
									else if(KeyTime.KeyPressed) return(8);
								 		else return(0);
	}
	
}